#include "collection.h"
#include "object.h"

// Standard Library
#include <stddef.h>

struct ap_object* ap_collection_from_uri( const char* uri )
{
	struct ap_object* col = ap_object_fetch(uri);
	if( !col ) { return NULL; }

	ap_object_ptr_or_ref_force_embedded( &col->first );
	return col;
}

void ap_collection_iterate( struct ap_object** page )
{
	if( !*page ) { return; }

	// Load the next page
	ap_object_ptr_or_ref_force_embedded( &(*page)->next );
	if( (*page)->next.ptr ) {
		*page = (*page)->next.ptr;
	} else {
		*page = NULL;
	}
}



