#include "ap/object.h"

#include "json/json.h"
#include "json/layout.h"


static bool total_items_reader( struct json_pull_parser* jpp, void* field_data, struct json_reflection* json_field_data, int offset )
{
	struct ap_object* o = field_data;

	return json_pull_parser_read_int( jpp, &o->total_items );
}

static bool total_items_writer( struct json_writer* jw, const char* field_name, void* field_data, struct json_reflection* json_field_data, int offset )
{
	struct ap_object* o = field_data;
	switch( o->type )
	{
		case ap_Collection:
		case ap_OrderedCollection:
			break;
		default:
			//printf( "Not collection, skipping totalItems field\n" );
			return false;
	}

	json_write_field_name(jw,field_name);
	fprintf( jw->f, "%d", o->total_items );

	return true;
}

struct json_field_type total_items_type = {
	.reader = total_items_reader,
	.writer = total_items_writer,
};

